#include "content/npcs.h"

/** Get NPC name by ID.
 * @return NPC's name or NULL when not found */
const char* Content::getNpcName(enum NPCIDs id)
{
  switch(id)
  {
  case BARRY:           return "BARRY";
  case BLOOD:           return "BLOOD";
  case LYNX:            return "LYNX";
  case GRIZZLY:         return "GRIZZLY";
  case VICKY:           return "VICKY";
  case TREVOR:          return "TREVOR";
  case GRUNTY:          return "GRUNTY";
  case IVAN:            return "IVAN";
  case STEROID:         return "STEROID";
  case IGOR:            return "IGOR";
  case SHADOW:          return "SHADOW";
  case RED:             return "RED";
  case REAPER:          return "REAPER";
  case FIDEL:           return "FIDEL";
  case FOX:             return "FOX";
  case SIDNEY:          return "SIDNEY";
  case GUS:             return "GUS";
  case BUNS:            return "BUNS";
  case ICE:             return "ICE";
  case SPIDER:          return "SPIDER";
  case CLIFF:           return "CLIFF";
  case RAVEN:           return "RAVEN";
  case MAGIC:           return "MAGIC";
  case DR_Q:            return "DR_Q";
  case NAILS:           return "NAILS";
  case SCOPE:           return "SCOPE";
  case BIFF:            return "BIFF";
  case HAYWIRE:         return "HAYWIRE";
  case GASKET:          return "GASKET";
  case RAZOR:           return "RAZOR";
  case FLO:             return "FLO";
  case GUMPY:           return "GUMPY";
  case LARRY_NORMAL:    return "LARRY_NORMAL";
  case LARRY_DRUNK:     return "LARRY_DRUNK";
  case COUGAR:          return "COUGAR";
  case NUMB:            return "NUMB";
  case BUBBA:           return "BUBBA";
  case MIGUEL:          return "MIGUEL";
  case CARLOS:          return "CARLOS";
  case IRA:             return "IRA";
  case DIMITRI:         return "DIMITRI";
  case DEVIN:           return "DEVIN";
  case ROBOT:           return "ROBOT";
  case HAMOUS:          return "HAMOUS";
  case SLAY:            return "SLAY";
  case RPC65:           return "RPC65";
  case DYNAMO:          return "DYNAMO";
  case SHANK:           return "SHANK";
  case IGGY:            return "IGGY";
  case VINCE:           return "VINCE";
  case CONRAD:          return "CONRAD";
  case RPC71:           return "RPC71";
  case MADDOG:          return "MADDOG";
  case DARREL:          return "DARREL";
  case PERKO:           return "PERKO";
  case QUEEN:           return "QUEEN";
  case AUNTIE:          return "AUNTIE";
  case ENRICO:          return "ENRICO";
  case CARMEN:          return "CARMEN";
  case JOE:             return "JOE";
  case STEVE:           return "STEVE";
  case RAT:             return "RAT";
  case ANNIE:           return "ANNIE";
  case CHRIS:           return "CHRIS";
  case BOB:             return "BOB";
  case BRENDA:          return "BRENDA";
  case KINGPIN:         return "KINGPIN";
  case DARREN:          return "DARREN";
  case MARIA:           return "MARIA";
  case ANGEL:           return "ANGEL";
  case JOEY:            return "JOEY";
  case TONY:            return "TONY";
  case FRANK:           return "FRANK";
  case SPIKE:           return "SPIKE";
  case DAMON:           return "DAMON";
  case KYLE:            return "KYLE";
  case MICKY:           return "MICKY";
  case SKYRIDER:        return "SKYRIDER";
  case PABLO:           return "PABLO";
  case SAL:             return "SAL";
  case FATHER:          return "FATHER";
  case FATIMA:          return "FATIMA";
  case WARDEN:          return "WARDEN";
  case GORDON:          return "GORDON";
  case GABBY:           return "GABBY";
  case ERNEST:          return "ERNEST";
  case FRED:            return "FRED";
  case MADAME:          return "MADAME";
  case YANNI:           return "YANNI";
  case MARTHA:          return "MARTHA";
  case TIFFANY:         return "TIFFANY";
  case T_REX:           return "T_REX";
  case DRUGGIST:        return "DRUGGIST";
  case JAKE:            return "JAKE";
  case PACOS:           return "PACOS";
  case GERARD:          return "GERARD";
  case SKIPPER:         return "SKIPPER";
  case HANS:            return "HANS";
  case JOHN:            return "JOHN";
  case MARY:            return "MARY";
  case GENERAL:         return "GENERAL";
  case SERGEANT:        return "SERGEANT";
  case ARMAND:          return "ARMAND";
  case LORA:            return "LORA";
  case FRANZ:           return "FRANZ";
  case HOWARD:          return "HOWARD";
  case SAM:             return "SAM";
  case ELDIN:           return "ELDIN";
  case ARNIE:           return "ARNIE";
  case TINA:            return "TINA";
  case FREDO:           return "FREDO";
  case WALTER:          return "WALTER";
  case JENNY:           return "JENNY";
  case BILLY:           return "BILLY";
  case BREWSTER:        return "BREWSTER";
  case ELLIOT:          return "ELLIOT";
  case DEREK:           return "DEREK";
  case OLIVER:          return "OLIVER";
  case WALDO:           return "WALDO";
  case DOREEN:          return "DOREEN";
  case JIM:             return "JIM";
  case JACK:            return "JACK";
  case OLAF:            return "OLAF";
  case RAY:             return "RAY";
  case OLGA:            return "OLGA";
  case TYRONE:          return "TYRONE";
  case MADLAB:          return "MADLAB";
  case KEITH:           return "KEITH";
  case MATT:            return "MATT";
  case MIKE:            return "MIKE";
  case DARYL:           return "DARYL";
  case HERVE:           return "HERVE";
  case PETER:           return "PETER";
  case ALBERTO:         return "ALBERTO";
  case CARLO:           return "CARLO";
  case MANNY:           return "MANNY";
  case OSWALD:          return "OSWALD";
  case CALVIN:          return "CALVIN";
  case CARL:            return "CARL";
  case SPECK:           return "SPECK";
  case PROF_HUMMER:     return "PROF_HUMMER";
  case PROF_ELDERODO:   return "PROF_ELDERODO";
  case PROF_ICECREAM:   return "PROF_ICECREAM";
  case PROF_HELICOPTER: return "PROF_HELICOPTER";
  case NPC164:          return "NPC164";
  case NPC165:          return "NPC165";
  case NPC166:          return "NPC166";
  case NPC167:          return "NPC167";
  case NPC168:          return "NPC168";
  case NPC169:          return "NPC169";
  default:              return NULL;
  };
}
